/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the Successor type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Successor{}

// Successor struct for Successor
type Successor struct {
	InteractionId *string `json:"interaction_id,omitempty"`
	EntryPointHandover *bool `json:"entry_point_handover,omitempty"`
}

// NewSuccessor instantiates a new Successor object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSuccessor() *Successor {
	this := Successor{}
	return &this
}

// NewSuccessorWithDefaults instantiates a new Successor object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSuccessorWithDefaults() *Successor {
	this := Successor{}
	return &this
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *Successor) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Successor) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *Successor) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *Successor) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetEntryPointHandover returns the EntryPointHandover field value if set, zero value otherwise.
func (o *Successor) GetEntryPointHandover() bool {
	if o == nil || IsNil(o.EntryPointHandover) {
		var ret bool
		return ret
	}
	return *o.EntryPointHandover
}

// GetEntryPointHandoverOk returns a tuple with the EntryPointHandover field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Successor) GetEntryPointHandoverOk() (*bool, bool) {
	if o == nil || IsNil(o.EntryPointHandover) {
		return nil, false
	}
	return o.EntryPointHandover, true
}

// HasEntryPointHandover returns a boolean if a field has been set.
func (o *Successor) HasEntryPointHandover() bool {
	if o != nil && !IsNil(o.EntryPointHandover) {
		return true
	}

	return false
}

// SetEntryPointHandover gets a reference to the given bool and assigns it to the EntryPointHandover field.
func (o *Successor) SetEntryPointHandover(v bool) {
	o.EntryPointHandover = &v
}

func (o Successor) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Successor) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.EntryPointHandover) {
		toSerialize["entry_point_handover"] = o.EntryPointHandover
	}
	return toSerialize, nil
}

type NullableSuccessor struct {
	value *Successor
	isSet bool
}

func (v NullableSuccessor) Get() *Successor {
	return v.value
}

func (v *NullableSuccessor) Set(val *Successor) {
	v.value = val
	v.isSet = true
}

func (v NullableSuccessor) IsSet() bool {
	return v.isSet
}

func (v *NullableSuccessor) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSuccessor(val *Successor) *NullableSuccessor {
	return &NullableSuccessor{value: val, isSet: true}
}

func (v NullableSuccessor) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSuccessor) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


